package com.loafle.overflow.module.infra.service;

import com.loafle.overflow.module.infra.model.InfraHost;
import com.loafle.overflow.module.infra.model.InfraOS;
import com.loafle.overflow.spring.AppConfig;
import com.loafle.overflow.spring.JdbcConfiguration;
import com.loafle.overflow.spring.MailConfiguration;
import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import static org.junit.Assert.*;

/**
 * Created by snoop on 17. 7. 27.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class, MailConfiguration.class})
public class InfraHostServiceTest {

    @Autowired
    private InfraHostService infraHostService;

    @Test
    public void regist() throws Exception {

        InfraHost infraHost = new InfraHost();

        infraHost.setMac(8796753988883L);
        infraHost.setIp(3232235980L);

        InfraOS infraOS = new InfraOS();
        infraOS.setId(1);

        infraHost.setOs(infraOS);

        this.infraHostService.regist(infraHost);

        Assert.assertNotEquals(infraHost.getId(), 0 );

    }

    @Test
    public void read() throws Exception {

        InfraHost infraHost = this.infraHostService.read(1);

        ObjectMapper objectMapper = new ObjectMapper();
        String json  = objectMapper.writeValueAsString(infraHost);

        System.out.println(json);

    }

}